/*
 * Copyright (c) 2002 - trem0r
 * This file is part of the PornView - photo collection manager.
 */

#ifndef __IMAGEVIEW_H__
#define __IMAGEVIEW_H__

typedef enum
{
    IMAGEVIEW_ZOOM_100,		/* Real Size */
    IMAGEVIEW_ZOOM_IN,		/* Increase Image Size 5% */
    IMAGEVIEW_ZOOM_OUT,		/* Decrease Image Size 5% */
    IMAGEVIEW_ZOOM_FIT,		/* Fit to Widnow */
}
ImgZoomType;

#define IMG_MIN_SCALE 5
#define IMG_MAX_SCALE 100000

#define IMGWIN_FULLSCREEN_HIDE_CURSOR_DELAY 1000

typedef struct _ImageView ImageView;

struct _ImageView
{
    GtkWidget      *container;
    GtkWidget      *table;
    GtkWidget      *event_box;

    GtkWidget      *draw_area;
    GtkWidget      *hscrollbar;
    GtkWidget      *vscrollbar;
    GtkWidget      *nav_button;
    GtkWidget      *menu_popup;

    GtkAdjustment  *hadj, *vadj;

    ImageLoader    *loader;
    GdkPixbuf      *image;
    GdkPixmap      *pixmap;
    GdkBitmap      *mask;

    gint            width;
    gint            height;

    gboolean        fit_to_frame;
    gboolean        keep_aspect;
    ImgZoomType     zoom;
    gfloat          x_scale;
    gfloat          y_scale;

    /*
     * information about image dragging 
     */
    guint           button;
    gboolean        pressed;
    gboolean        dragging;
    gint            drag_startx;
    gint            drag_starty;
    gint            x_pos;
    gint            y_pos;
    gint            x_pos_drag_start;
    gint            y_pos_drag_start;

    GtkWidget      *fullscreen;
    gboolean        is_fullscreen;
    gint            hide_cursor_timer_id;

    gboolean        is_slideshow;
    gint            slideshow_timer_id;

    gboolean        is_hide;
};

ImageView      *imageview;

void            imageview_create (void);
void            imageview_destroy (void);
void            imageview_stop (void);
void            imageview_set_image (gchar * path);

void            imageview_get_image_frame_size (ImageView * iv, gint * width,
						gint * height);
void            imageview_zoom_image (ImageView * iv, ImgZoomType zoom,
				      gfloat x_scale, gfloat y_scale);
void            imageview_moveto (ImageView * iv, gint x, gint y);
void            imageview_fullscreen_mode_set (ImageView * iv);
void            imageview_slideshow_start (ImageView * iv);

#endif /* __IMAGEVIEW_H__ */
